from keyclasses import *


WIDTH, HEIGHT = 630, 150
WIDTH_HIDDEN, HEIGHT_HIDDEN = 82,26
ALPHA_LINES=0.3
ALPHA_FILL=0.5
ALPHA_TEXT=0.9

KEYBOARD_MIDDLE_DIM=[2,23,540,126]
KEYBOARD_MIDDLE=[
    [KSym("`~",cc=0,cc2=30),
     KNum("1!",cc=49,cc2=33),KNum("2@",cc=0,cc2=0),KNum("3#",cc=27,cc2=35),
     KNum("4$",cc=28,cc2=36),KNum("5%",cc=29,cc2=37),KNum("6^",cc=30),
     KNum("7&",cc=31,cc2=38),KNum("8*",cc=127,cc2=42),KNum("9("),KNum("0)"),
     KSym("-_",cc=45,cc2=31),KSym("=+"),Key("<-",[127],size=1.6)],
    [Key("->|",[9],size=1.6),KLet("qQ"),KLet("wW"),KLet("eE"),KLet("rR"),KLet("tT"),KLet("yY"),
     KLet("uU"),KLet("iI"),KLet("oO"),KLet("pP"),KSym("[{",cc=27),KSym("]}",cc=29),KSym("\|",cc=28)],
    [KMod("CAPS","S",size=1.6),Spacer(size=0.3),KLet("aA"),KLet("sS"),KLet("dD"),KLet("fF"),KLet("gG"),KLet("hH"),
     KLet("jJ"),KLet("kK"),KLet("lL"),KSym(";:"),KSym("'\""),Key("Enter",[13], size=2.1)],
    [KMod("Shift","s",size=2.1),KLet("zZ"),KLet("xX"),KLet("cC"),KLet("vV"),KLet("bB"),KLet("nN"),KLet("mM"),KSym(",<"),KSym(".>"),KSym("/?",cc=31,cc2=127),KMod("Shift","s",size=2.1)],
    [KMod("Ctrl","c",size=1.8),KMod("Alt","a",size=1.8),KSym("  ",cc=27,size=5.0),KMod("Alt","a",size=1.8),KMod("Ctrl","c",size=1.8)]]

KEYBOARD_FN_DIM=[2,1,540,16]
KEYBOARD_FN=[
    [Key("ESC",[27]),Spacer(size=1.0),
     KFn("F1",[27,79,80],[27,79,50,80]),KFn("F2",[27,79,81],[27,79,50,81]),
     KFn("F3",[27,79,82],[27,79,50,82]),KFn("F4",[27,79,83],[27,79,50,83]),
     Spacer(size=0.4),
     KFn("F5",[27,91,49,53,126],[27,91,49,53,59,50,126]),KFn("F6",[27,91,49,55,126],[27,91,49,55,59,50,126]),
     KFn("F7",[27,91,49,56,126],[27,91,49,56,59,50,126]),KFn("F8",[27,91,49,57,126],[27,91,49,57,59,50,126]),
     Spacer(size=0.4),
     KFn("F9",[27,91,50,48,126],[27,91,50,48,59,50,126]),KFn("F10",[27,91,50,49,126],[27,91,50,49,59,50,126]),
     KFn("F11",[27,91,50,51,126],[27,91,50,51,59,50,126]),KFn("F12",[27,91,50,52,126],[27,91,50,52,59,50,126]),
    ]]

KEYBOARD_SPEC_DIM=[548,1,81,25]
KEYBOARD_SPEC_DIM_HIDDEN=[0,0,81,25]
KEYBOARD_SPEC=[[KMod("Hide","h",font_size=10),KMod("Inv","i",font_size=10),KMod("Move","m",font_size=10)]]

KEYBOARD_EDITMOVE_DIM=[548,32,81,50]
KEYBOARD_EDITMOVE=[
    [KFn("Ins",[27,91,50,126],[],font_size=9),KFn("Home",[27,91,72],[],font_size=9),
     KFn("PgUp",[27,91,53,126],[],font_size=9)],
    [KFn("Del",[27,91,51,126],[],font_size=9),KFn("End",[27,91,70],[],font_size=9),
     KFn("PgDn",[27,91,54,126],[],font_size=9)]
    ]

KEYBOARD_ARROWS_DIM=[548,90,81,50]
KEYBOARD_ARROWS=[
    [Spacer(size=1.0),KFn("^",[27,91,65],[27,91,49,59,50,65]),Spacer(size=1.0)],
    [KFn("<",[27,91,68],[27,91,49,59,50,68]),KFn("v",[27,91,66],[27,91,49,59,50,66]),
     KFn(">",[27,91,67],[27,91,49,59,50,67])]
    ]

ALL_BLOCKS_NORMAL=[
    (KEYBOARD_MIDDLE, KEYBOARD_MIDDLE_DIM),
    (KEYBOARD_FN, KEYBOARD_FN_DIM),
    (KEYBOARD_SPEC, KEYBOARD_SPEC_DIM),
    (KEYBOARD_EDITMOVE, KEYBOARD_EDITMOVE_DIM),
    (KEYBOARD_ARROWS, KEYBOARD_ARROWS_DIM)]

ALL_BLOCKS_HIDDEN=[
    (KEYBOARD_SPEC, KEYBOARD_SPEC_DIM_HIDDEN)
    ]


KEYBOARD_SETS=[
    {
    'name':'ns',
    'blocks':ALL_BLOCKS_NORMAL,
    'width':WIDTH,
    'height':HEIGHT,
    'BORDER_COLOR':[0.8,0.8,1.0,ALPHA_LINES],
    'BORDER_COLOR2':[0.0,0.0,0.0,ALPHA_FILL],
    'TEXT_COLOR':[0.8,1.0,0.8,ALPHA_TEXT],
    'TEXT_COLORBG':[0.0,0.0,0.0,ALPHA_TEXT]
    },
    {
    'name':'nh',
    'blocks':ALL_BLOCKS_HIDDEN,
    'width':WIDTH_HIDDEN,
    'height':HEIGHT_HIDDEN,
    'BORDER_COLOR':[0.8,0.8,1.0,ALPHA_LINES],
    'BORDER_COLOR2':[0.0,0.0,0.0,ALPHA_FILL],
    'TEXT_COLOR':[0.8,1.0,0.8,ALPHA_TEXT],
    'TEXT_COLORBG':[0.0,0.0,0.0,ALPHA_TEXT]
    },
    {
    'name':'is',
    'blocks':ALL_BLOCKS_NORMAL,
    'width':WIDTH,
    'height':HEIGHT,
    'BORDER_COLOR':[0.2,0.2,0.0,ALPHA_LINES],
    'BORDER_COLOR2':[1.0,1.0,1.0,ALPHA_FILL],
    'TEXT_COLOR':[0.2,0.0,0.2,ALPHA_TEXT],
    'TEXT_COLORBG':[1.0,1.0,1.0,ALPHA_TEXT]
    },
    {
    'name':'ih',
    'blocks':ALL_BLOCKS_HIDDEN,
    'width':WIDTH_HIDDEN,
    'height':HEIGHT_HIDDEN,
    'BORDER_COLOR':[0.2,0.2,0.0,ALPHA_LINES],
    'BORDER_COLOR2':[1.0,1.0,1.0,ALPHA_FILL],
    'TEXT_COLOR':[0.2,0.0,0.2,ALPHA_TEXT],
    'TEXT_COLORBG':[1.0,1.0,1.0,ALPHA_TEXT]
    }
    ]
