
global draw_button

#'s'-shift, 'S'-CAPS, 'c'-ctrl, 'a'-meta/alt
# or char of special key 'h'-hide, 'i'-invert, 'm'-move
SPECIAL_KEYCODES={
    'h':500,
    'i':501,
    'm':502,
    's':503,
    'S':504,
    'c':505,
    'a':506
    }


class Key:
    def __init__(self,desc,codes=[],cc=None,cc2=None,size=1.0,font_size=15):
        self.desc=desc
        self.size=size
        self.codes=codes
        self.ctrlcodes=[]
        if cc!=None: self.ctrlcodes=[cc]
        self.ctrlcodes2=self.ctrlcodes
        if cc2!=None: self.ctrlcodes2=[cc2]
        self.x=None
        self.y=None
        self.w=None
        self.h=None
        self.font_size=font_size
    def render(self,ctx,x,y,w,h):
        draw_button(ctx,self.desc,self.font_size,x,y,w,h)
    def get_chars(self):
        # should return list of byte sequences
        # [normal_byte_seq, shift_byte_seq, ctrl_byte_seq, shift_ctrl_byte_seq]
        # or char of special key codes as defined in SPECIAL_KEYCODES dict
        # or None for non-keys
        return [self.codes,self.codes,self.ctrlcodes,self.ctrlcodes2]
    def get_size(self):
        return self.size
    def set_placement(self,x,y,w,h):
        self.x=x; self.y=y; self.w=w; self.h=h
    def get_placement(self):
        return [self.x, self.y, self.w, self.h]

class Spacer(Key):
    def __init__(self,size=1.0):
        self.size=size
    def render(self,ctx,x,y,w,h):
        pass
    def get_chars(self):
        return None

class KSym(Key):
    def render(self,ctx,x,y,w,h):
        draw_button(ctx,self.desc[0],17,x,y,w,h,text2=self.desc[1])
    def get_chars(self):
        return [[ord(self.desc[0])],[ord(self.desc[1])],self.ctrlcodes,self.ctrlcodes2]

class KNum(KSym):
    def render(self,ctx,x,y,w,h):
        draw_button(ctx,self.desc[0],17,x,y,w,h, text2=self.desc[1])

class KLet(Key):
    def render(self,ctx,x,y,w,h):
        draw_button(ctx,self.desc[1],20,x,y,w,h)
    def get_chars(self):
        ctrl=[ord(self.desc[1])-64]
        return [[ord(self.desc[0])],[ord(self.desc[1])],ctrl,ctrl]
    
class KMod(Key):
    def __init__(self,desc,mode,size=1.0,font_size=15):
        Key.__init__(self,desc,size=size,font_size=font_size)
        self.mode=mode
    def get_chars(self):
        return self.mode

class KFn(Key):
    def __init__(self,desc,codes,codes2,size=1.0,font_size=15):
        Key.__init__(self,desc,size=size,font_size=font_size)
        self.codes=codes
        self.codes2=codes2
    def get_chars(self):
        return [self.codes,self.codes2,[],[]]
